= nng_msg_dup(3)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_msg_dup - duplicate a message

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>

int nng_msg_dup(nng_msg **dup, nng_msg_t *orig);
----

== DESCRIPTION

The `nng_msg_dup()` makes a duplicate of the original message _orig_, and
saves the result in the location pointed by _dup_.
The actual message body and header content is copied,
but the duplicate may contain a
different amount of unused space than the original message.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient free memory exists to duplicate a message.

== SEE ALSO

[.text-left]
xref:nng_msg_alloc.3.adoc[nng_msg_alloc(3)],
xref:nng_msg_free.3.adoc[nng_msg_free(3)],
xref:nng_strerror.3.adoc[nng_strerror(3)],
xref:nng_msg.5.adoc[nng_msg(5)],
xref:nng.7.adoc[nng(7)]
